#include "ogse_config.h"

uniform float4 ogse_c_resolution;
half3 blendSoftLight(half3 a, half3 b)
{
	half3 c = 2 * a * b * ( 1 + a * (  1 - b ) );
	half3 a_sqrt = sqrt( a );
	half3 d = ( a  +  b * (a_sqrt - a )) * 2 - a_sqrt;
	return( b < 0.5 )? c : d;
};
half3 calc_sunshafts(float2 tc)
{
	// dist to the sun
	float sun_dist = FARPLANE / (sqrt(1 - L_sun_dir_w.y * L_sun_dir_w.y));
	// sun pos
	float3 sun_pos_world = sun_dist*L_sun_dir_w + eye_position;
	float4 sun_pos_projected = mul(m_VP, float4(sun_pos_world, 1));
	float4 sun_pos_screen = convert_to_screen_space(sun_pos_projected)/sun_pos_projected.w;
	// sun-pixel vector
	float2 sun_vec_screen = normalize(sun_pos_screen.xy - tc) * 4;
	// smooth shafts
	half4 cSunShafts = tex2D(s_sun_shafts, tc)*0.5;
	cSunShafts += tex2D(s_sun_shafts, tc + sun_vec_screen.yx * ogse_c_resolution.zw)*0.25;
	cSunShafts += tex2D(s_sun_shafts, tc - sun_vec_screen.yx * ogse_c_resolution.zw)*0.25;
	half3 img = tex2D(s_image, tc).xyz;
	
	half3 Color =  img + cSunShafts.xyz * L_sun_color.xyz * ( 1 - img ) * SS_INTENSITY /** c_sunshafts.x*/;
	return Color;
}